package com.adventurer_engine.network;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import adventurer_core.reflactions.PackageClassGetter;
import by;
import ci;
import com.adventurer_engine.util.DebugGadgets;
import com.google.common.collect.BiMap;
import com.google.common.collect.ImmutableBiMap;
import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteArrayDataOutput;
import com.google.common.io.ByteStreams;
import cpw.mods.fml.common.network.PacketDispatcher;
import cpw.mods.fml.relauncher.Side;
import ey;
import java.io.IOException;
import java.util.List;
import uf;

public abstract class RCsPacket {
  private static BiMap<Integer, Class<? extends com.adventurer_engine.network.RCsPacket>> idMap;
  
  private static ImmutableBiMap.Builder<Integer, Class<? extends com.adventurer_engine.network.RCsPacket>> builder = ImmutableBiMap.builder();
  
  private static int idx = 0;
  
  public static void addPackagePath(String path) {
    try {
      List<Class<?>> classes = PackageClassGetter.getClasses(path);
      for (Class<?> clazz : classes)
        builder.put(Integer.valueOf(idx++), clazz); 
      idMap = builder.build();
    } catch (Exception e) {
      DebugGadgets.debugInfo(e.getMessage());
    } 
  }
  
  public static com.adventurer_engine.network.RCsPacket constructPacket(int packetId) throws ProtocolException, InstantiationException, IllegalAccessException {
    Class<? extends com.adventurer_engine.network.RCsPacket> clazz = idMap.get(Integer.valueOf(packetId));
    if (clazz == null)
      throw new ProtocolException("Unknown Packet Id!"); 
    return clazz.newInstance();
  }
  
  public final int getPacketId() {
    if (idMap.inverse().containsKey(getClass()))
      return ((Integer)idMap.inverse().get(getClass())).intValue(); 
    throw new RuntimeException("Packet " + getClass().getSimpleName() + " is missing a mapping!");
  }
  
  public final ey makePacket() {
    return makePacket("adv_channel");
  }
  
  public final ey makePacket(String channel) {
    ByteArrayDataOutput dataOut = ByteStreams.newDataOutput();
    try {
      write(dataOut);
    } catch (IOException e) {
      System.err.println("Error writing packet: " + e);
    } 
    byte[] data = dataOut.toByteArray();
    ByteArrayDataOutput packetOut = ByteStreams.newDataOutput();
    packetOut.writeInt(getPacketId());
    packetOut.write(data);
    return (ey)PacketDispatcher.getPacket(channel, packetOut.toByteArray());
  }
  
  public abstract void write(ByteArrayDataOutput paramByteArrayDataOutput) throws IOException;
  
  public abstract void read(ByteArrayDataInput paramByteArrayDataInput) throws IOException;
  
  public abstract void execute(uf paramuf, Side paramSide) throws ProtocolException;
  
  public void process(ByteArrayDataInput in, uf player, Side side) throws IOException, ProtocolException {
    read(in);
    execute(player, side);
  }
  
  public static void writeNBTTagCompound(by compound, ByteArrayDataOutput out) throws IOException {
    if (compound == null) {
      out.writeShort(-1);
    } else {
      byte[] abyte = ci.a(compound);
      out.writeShort((short)abyte.length);
      out.write(abyte);
    } 
  }
  
  public static by readNBTTagCompound(ByteArrayDataInput in) throws IOException {
    short short1 = in.readShort();
    if (short1 < 0)
      return null; 
    byte[] abyte = new byte[short1];
    in.readFully(abyte);
    return ci.a(abyte);
  }
  
  public static com.adventurer_engine.network.RCsPacket packetFactory(int id) throws InstantiationException, IllegalAccessException {
    Class<? extends com.adventurer_engine.network.RCsPacket> c = idMap.get(Integer.valueOf(id));
    if (c == null)
      throw new RuntimeException(String.format("Invalid packet id: %d", new Object[] { Integer.valueOf(id) })); 
    return c.newInstance();
  }
}
